Index: /palm/trunk/SOURCE/multi_agent_system_mod.f90
===================================================================
--- /palm/trunk/SOURCE/multi_agent_system_mod.f90	(revision 4752)
+++ /palm/trunk/SOURCE/multi_agent_system_mod.f90	(revision 4753)
@@ -2195,536 +1985,631 @@
        ENDDO
 
-!
-!--    Send front boundary, receive back boundary (but first exchange how many
-!--    and chec if agent storage must be extended)
-       IF ( pdims(2) /= 1 )  THEN
-
-          CALL MPI_SENDRECV( trsa_count,      1, MPI_INTEGER, psouth, 0,       &
-                             trna_count_recv, 1, MPI_INTEGER, pnorth, 0,       &
-                             comm2d, status, ierr )
-
-          ALLOCATE(rvna(MAX(1,trna_count_recv)))
-!
-!--       This MPI_SENDRECV should work even with odd mixture on 32 and 64 Bit 
-!--       variables in structure agent_type (due to the calculation of par_size)
-          par_size = STORAGE_SIZE(trsa(1))/8
-          CALL MPI_SENDRECV( trsa, trsa_count*par_size, MPI_BYTE,              &
-                             psouth, 1, rvna,                                  &
-                             trna_count_recv*par_size, MPI_BYTE, pnorth, 1,    &
-                             comm2d, status, ierr )
-
-          IF ( trna_count_recv  > 0 ) THEN
-             CALL mas_eh_add_agents_to_gridcell(rvna(1:trna_count_recv))
-          ENDIF
-
-          DEALLOCATE(rvna)
-
-!
-!--       Send back boundary, receive front boundary
-          CALL MPI_SENDRECV( trna_count,      1, MPI_INTEGER, pnorth, 0,       &
-                             trsa_count_recv, 1, MPI_INTEGER, psouth, 0,       &
-                             comm2d, status, ierr )
-
-          ALLOCATE(rvsa(MAX(1,trsa_count_recv)))
-!
-!--       This MPI_SENDRECV should work even with odd mixture on 32 and 64 Bit 
-!--       variables in structure agent_type (due to the calculation of par_size)
-          par_size = STORAGE_SIZE(trna(1))/8
-          CALL MPI_SENDRECV( trna, trna_count*par_size, MPI_BYTE,              &
-                             pnorth, 1, rvsa,                                  &
-                             trsa_count_recv*par_size, MPI_BYTE, psouth, 1,    &
-                             comm2d, status, ierr )
-
-          IF ( trsa_count_recv > 0 ) THEN
-             CALL mas_eh_add_agents_to_gridcell(rvsa(1:trsa_count_recv))
-          ENDIF
-
-          DEALLOCATE(rvsa)
-
-          number_of_agents = number_of_agents + trsa_count_recv
-
-          DEALLOCATE( trsa, trna )
-
-       ENDIF
-
-       DEALLOCATE( move_also_north )
-       DEALLOCATE( move_also_south )
-
-!
-!--    Accumulate the number of agents transferred between the subdomains)
-       CALL mas_eh_ghost_exchange
-
-#else
-
-       DO  ip = nxl, nxr, nxr-nxl
-          DO  jp = nys, nyn
-             number_of_agents = agt_count(jp,ip)
-             IF ( number_of_agents <= 0 )  CYCLE
-             agents => grid_agents(jp,ip)%agents(1:number_of_agents)
-             DO  n = 1, number_of_agents
-!
-!--             Apply boundary conditions
-                IF ( agents(n)%x < 0.0_wp )  THEN
-
-                   IF ( ibc_mas_lr == 0 )  THEN
-!
-!--                   Cyclic boundary. Relevant coordinate has to be changed.
-                      agents(n)%x = ( nx + 1 ) * dx + agents(n)%x
-                      agents(n)%origin_x = ( nx + 1 ) * dx + &
-                                  agents(n)%origin_x
-                   ELSEIF ( ibc_mas_lr == 1 )  THEN
-!
-!--                   Agent absorption
+       IF ( trsa_count  == 0 )  trsa_count  = 1
+       IF ( trna_count  == 0 )  trna_count  = 1
+
+       ALLOCATE( trsa(trsa_count), trna(trna_count) )
+
+       trsa = zero_agent
+       trna = zero_agent
+
+       trsa_count  = nr_move_south
+       trna_count  = nr_move_north
+
+       trsa(1:nr_move_south) = move_also_south(1:nr_move_south)
+       trna(1:nr_move_north) = move_also_north(1:nr_move_north)
+
+    ENDIF
+
+    DO  ip = nxl, nxr
+       DO  jp = nys, nyn, nyn-nys ! compute only first (nys) and last (nyn) loop iterration
+          number_of_agents = agt_count(jp,ip)
+          IF ( number_of_agents <= 0 )  CYCLE
+          agents => grid_agents(jp,ip)%agents(1:number_of_agents)
+          DO  n = 1, number_of_agents
+!
+!--          Only those agents that have not been marked as 'deleted' may be moved.
+             IF ( agents(n)%agent_mask )  THEN
+
+                j = agents(n)%y * ddy
+!
+!--             Above calculation does not work for indices less than zero
+                IF ( agents(n)%y < 0.0_wp * dy )  j = -1
+
+                IF ( j < nys )  THEN
+                   IF ( j < 0 )  THEN
+!
+!--                   Apply boundary condition along y
+                      IF ( ibc_mas_ns == 0 )  THEN
+!
+!--                      Cyclic condition
+                         IF ( pdims(2) == 1 )  THEN
+                            agents(n)%y = ( ny + 1 ) * dy + agents(n)%y
+                            agents(n)%origin_y = ( ny + 1 ) * dy + agents(n)%origin_y
+                         ELSE
+                            trsa_count         = trsa_count + 1
+                            trsa(trsa_count)   = agents(n)
+                            trsa(trsa_count)%y = ( ny + 1 ) * dy + trsa(trsa_count)%y
+                            trsa(trsa_count)%origin_y = trsa(trsa_count)%origin_y + ( ny + 1 ) * dy
+                            agents(n)%agent_mask = .FALSE.
+                            deleted_agents = deleted_agents + 1
+
+                            IF ( trsa(trsa_count)%y >= (ny+1)* dy - 1.0E-12_wp )  THEN
+                               trsa(trsa_count)%y = trsa(trsa_count)%y - 1.0E-10_wp
+                               trsa(trsa_count)%origin_y = trsa(trsa_count)%origin_y - 1
+                            ENDIF
+
+                         ENDIF
+
+                      ELSEIF ( ibc_mas_ns == 1 )  THEN
+!
+!--                      Agent absorption
+                         agents(n)%agent_mask = .FALSE.
+                         deleted_agents          = deleted_agents + 1
+
+                      ENDIF
+                   ELSE
+!
+!--                   Store agent data in the transfer array, which will be send to the neighbouring
+!--                   PE.
+                      trsa_count = trsa_count + 1
+                      trsa(trsa_count) = agents(n)
                       agents(n)%agent_mask = .FALSE.
                       deleted_agents = deleted_agents + 1
+
                    ENDIF
 
-                ELSEIF ( agents(n)%x >= ( nx + 1 ) * dx )  THEN
-
-                   IF ( ibc_mas_lr == 0 )  THEN
-!
-!--                   Cyclic boundary. Relevant coordinate has to be changed.
-                      agents(n)%x = agents(n)%x - ( nx + 1 ) * dx
-
-                   ELSEIF ( ibc_mas_lr == 1 )  THEN
-!
-!--                   Agent absorption
+                ELSEIF ( j > nyn )  THEN
+                   IF ( j > ny )  THEN
+!
+!--                   Apply boundary condition along y
+                      IF ( ibc_mas_ns == 0 )  THEN
+!
+!--                      Cyclic condition
+                         IF ( pdims(2) == 1 )  THEN
+                            agents(n)%y        = agents(n)%y        - ( ny + 1 ) * dy
+                            agents(n)%origin_y = agents(n)%origin_y - ( ny + 1 ) * dy
+                         ELSE
+                            trna_count         = trna_count + 1
+                            trna(trna_count)   = agents(n)
+                            trna(trna_count)%y = trna(trna_count)%y - ( ny + 1 ) * dy
+                            trna(trna_count)%origin_y = trna(trna_count)%origin_y - ( ny + 1 ) * dy
+                            agents(n)%agent_mask = .FALSE.
+                            deleted_agents          = deleted_agents + 1
+                         ENDIF
+
+                      ELSEIF ( ibc_mas_ns == 1 )  THEN
+!
+!--                      Agent absorption
+                         agents(n)%agent_mask = .FALSE.
+                         deleted_agents = deleted_agents + 1
+
+                      ENDIF
+                   ELSE
+!
+!--                   Store agent data in the transfer array, which will be send to the neighbouring
+!--                   PE
+                      trna_count = trna_count + 1
+                      trna(trna_count) = agents(n)
                       agents(n)%agent_mask = .FALSE.
                       deleted_agents = deleted_agents + 1
+
                    ENDIF
 
+                ENDIF
+             ENDIF
+          ENDDO
+       ENDDO
+    ENDDO
+
+!
+!-- Send front boundary, receive back boundary (but first exchange how many and check if agent
+!-- storage must be extended).
+    IF ( pdims(2) /= 1 )  THEN
+
+       CALL MPI_SENDRECV( trsa_count,      1, MPI_INTEGER, psouth, 0,                              &
+                          trna_count_recv, 1, MPI_INTEGER, pnorth, 0,                              &
+                          comm2d, status, ierr )
+
+       ALLOCATE( rvna( MAX( 1, trna_count_recv )) )
+!
+!--    This MPI_SENDRECV should work even with odd mixture on 32 and 64 Bit variables in structure
+!--    agent_type (due to the calculation of par_size)
+       par_size = STORAGE_SIZE(trsa(1))/8
+       CALL MPI_SENDRECV( trsa, trsa_count * par_size,      MPI_BYTE, psouth, 1,                   &
+                          rvna, trna_count_recv * par_size, MPI_BYTE, pnorth, 1,                   &
+                          comm2d, status, ierr )
+
+       IF ( trna_count_recv  > 0 )  THEN
+          CALL mas_eh_add_agents_to_gridcell(rvna(1:trna_count_recv))
+       ENDIF
+
+       DEALLOCATE( rvna )
+
+!
+!--    Send back boundary, receive front boundary
+       CALL MPI_SENDRECV( trna_count,      1, MPI_INTEGER, pnorth, 0,                              &
+                          trsa_count_recv, 1, MPI_INTEGER, psouth, 0,                              &
+                          comm2d, status, ierr )
+
+       ALLOCATE( rvsa( MAX( 1, trsa_count_recv )) )
+!
+!--    This MPI_SENDRECV should work even with odd mixture on 32 and 64 Bit variables in structure
+!--    agent_type (due to the calculation of par_size)
+       par_size = STORAGE_SIZE( trna(1) ) / 8
+       CALL MPI_SENDRECV( trna, trna_count * par_size,      MPI_BYTE, pnorth, 1,                   &
+                          rvsa, trsa_count_recv * par_size, MPI_BYTE, psouth, 1,                   &
+                          comm2d, status, ierr )
+
+       IF ( trsa_count_recv > 0 )  THEN
+          CALL mas_eh_add_agents_to_gridcell(rvsa(1:trsa_count_recv))
+       ENDIF
+
+       DEALLOCATE( rvsa )
+
+       number_of_agents = number_of_agents + trsa_count_recv
+
+       DEALLOCATE( trsa, trna )
+
+    ENDIF
+
+    DEALLOCATE( move_also_north )
+    DEALLOCATE( move_also_south )
+
+!
+!-- Accumulate the number of agents transferred between the subdomains)
+    CALL mas_eh_ghost_exchange
+
+#else
+
+    DO  ip = nxl, nxr, nxr-nxl
+       DO  jp = nys, nyn
+          number_of_agents = agt_count(jp,ip)
+          IF ( number_of_agents <= 0 )  CYCLE
+          agents => grid_agents(jp,ip)%agents(1:number_of_agents)
+          DO  n = 1, number_of_agents
+!
+!--          Apply boundary conditions
+             IF ( agents(n)%x < 0.0_wp )  THEN
+
+                IF ( ibc_mas_lr == 0 )  THEN
+!
+!--                Cyclic boundary. Relevant coordinate has to be changed.
+                   agents(n)%x = ( nx + 1 ) * dx + agents(n)%x
+                   agents(n)%origin_x = ( nx + 1 ) * dx + agents(n)%origin_x
+                ELSEIF ( ibc_mas_lr == 1 )  THEN
+!
+!--                Agent absorption
+                   agents(n)%agent_mask = .FALSE.
+                   deleted_agents = deleted_agents + 1
+                ENDIF
+
+             ELSEIF ( agents(n)%x >= ( nx + 1 ) * dx )  THEN
+
+                IF ( ibc_mas_lr == 0 )  THEN
+!
+!--                Cyclic boundary. Relevant coordinate has to be changed.
+                   agents(n)%x = agents(n)%x - ( nx + 1 ) * dx
+
+                ELSEIF ( ibc_mas_lr == 1 )  THEN
+!
+!--                Agent absorption
+                   agents(n)%agent_mask = .FALSE.
+                   deleted_agents = deleted_agents + 1
+                ENDIF
+
+             ENDIF
+          ENDDO
+       ENDDO
+    ENDDO
+
+    DO  ip = nxl, nxr
+       DO  jp = nys, nyn, nyn-nys
+          number_of_agents = agt_count(jp,ip)
+          IF ( number_of_agents <= 0 )  CYCLE
+          agents => grid_agents(jp,ip)%agents(1:number_of_agents)
+          DO  n = 1, number_of_agents
+
+             IF ( agents(n)%y < 0.0_wp )  THEN
+
+                IF ( ibc_mas_ns == 0 )  THEN
+!
+!--                Cyclic boundary. Relevant coordinate has to be changed.
+                   agents(n)%y = ( ny + 1 ) * dy + agents(n)%y
+                   agents(n)%origin_y = ( ny + 1 ) * dy + &
+                        agents(n)%origin_y
+
+                ELSEIF ( ibc_mas_ns == 1 )  THEN
+!
+!--                Agent absorption
+                   agents(n)%agent_mask = .FALSE.
+                   deleted_agents = deleted_agents + 1
+                ENDIF
+
+             ELSEIF ( agents(n)%y >= ( ny + 0.5_wp ) * dy )  THEN
+
+                IF ( ibc_mas_ns == 0 )  THEN
+!
+!--                Cyclic boundary. Relevant coordinate has to be changed.
+                   agents(n)%y = agents(n)%y - ( ny + 1 ) * dy
+
+                ELSEIF ( ibc_mas_ns == 1 )  THEN
+!
+!--                Agent absorption
+                   agents(n)%agent_mask = .FALSE.
+                   deleted_agents = deleted_agents + 1
+                ENDIF
+
+             ENDIF
+
+          ENDDO
+       ENDDO
+    ENDDO
+#endif
+
+ END SUBROUTINE mas_eh_exchange_horiz
+
+
+#if defined( __parallel )
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Sends the agents from the three gridcells closest to the north/south/left/right border of a PE to
+!> the corresponding neighbors ghost layer (which is three grid boxes deep)
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE mas_eh_ghost_exchange
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  agt_size    !< Bit size of agent datatype
+    INTEGER(iwp) ::  ghla_count  !< ghost points left agent
+    INTEGER(iwp) ::  ghna_count  !< ghost points north agent
+    INTEGER(iwp) ::  ghra_count  !< ghost points right agent
+    INTEGER(iwp) ::  ghsa_count  !< ghost points south agent
+    INTEGER(iwp) ::  ip          !< index variable along x
+    INTEGER(iwp) ::  jp          !< index variable along y
+
+    LOGICAL ::  ghla_empty      !< ghost points left agent
+    LOGICAL ::  ghla_empty_rcv  !< ghost points left agent
+    LOGICAL ::  ghna_empty      !< ghost points north agent
+    LOGICAL ::  ghna_empty_rcv  !< ghost points north agent
+    LOGICAL ::  ghra_empty      !< ghost points right agent
+    LOGICAL ::  ghra_empty_rcv  !< ghost points right agent
+    LOGICAL ::  ghsa_empty      !< ghost points south agent
+    LOGICAL ::  ghsa_empty_rcv  !< ghost points south agent
+
+    TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  ghla  !< agents received from right PE
+    TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  ghna  !< agents received from south PE
+    TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  ghra  !< agents received from left PE
+    TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  ghsa  !< agents received from north PE
+
+    ghla_empty = .TRUE.
+    ghna_empty = .TRUE.
+    ghra_empty = .TRUE.
+    ghsa_empty = .TRUE.
+!
+!-- Reset ghost layer
+    DO  ip = nxlg, nxl-1
+       DO  jp = nysg, nyng
+          agt_count(jp,ip) = 0
+       ENDDO
+    ENDDO
+    DO  ip = nxr+1, nxrg
+       DO  jp = nysg, nyng
+          agt_count(jp,ip) = 0
+       ENDDO
+    ENDDO
+    DO  ip = nxl, nxr
+       DO  jp = nysg, nys-1
+          agt_count(jp,ip) = 0
+       ENDDO
+    ENDDO
+    DO  ip = nxl, nxr
+       DO  jp = nyn+1, nyng
+          agt_count(jp,ip) = 0
+       ENDDO
+    ENDDO
+!
+!-- Transfer of agents from left to right and vice versa
+    IF ( pdims(1) /= 1 )  THEN
+!
+!--    Reset left and right ghost layers
+       ghla_count  = 0
+       ghra_count  = 0
+!
+!--    First calculate the storage necessary for sending and receiving the data.
+       ghla_count = SUM(agt_count(nys:nyn,nxl:nxl+2))
+       ghra_count = SUM(agt_count(nys:nyn,nxr-2:nxr))
+!
+!--    No cyclic boundaries for agents
+       IF ( nxl == 0  .OR.  ghla_count == 0 )  THEN
+          ghla_count = 1
+       ELSE
+          ghla_empty = .FALSE.
+       ENDIF
+       IF ( nxr == nx  .OR.  ghra_count == 0 )  THEN
+          ghra_count = 1
+       ELSE
+          ghra_empty = .FALSE.
+       ENDIF
+       ALLOCATE( ghla(1:ghla_count), ghra(1:ghra_count) )
+       ghla = zero_agent
+       ghra = zero_agent
+!
+!--    Get all agents that will be sent left into one array
+       ghla_count = 0
+       IF ( nxl /= 0 )  THEN
+          DO  ip = nxl, nxl+2
+             DO jp = nys, nyn
+
+                number_of_agents = agt_count(jp,ip)
+                IF ( number_of_agents <= 0 )  CYCLE
+                ghla(ghla_count+1:ghla_count+number_of_agents)                                     &
+                                                     = grid_agents(jp,ip)%agents(1:number_of_agents)
+                ghla_count = ghla_count + number_of_agents
+
+             ENDDO
+          ENDDO
+       ENDIF
+       IF ( ghla_count == 0 )  ghla_count = 1
+!
+!--    Get all agents that will be sent right into one array
+       ghra_count = 0
+       IF ( nxr /= nx )  THEN
+          DO  ip = nxr-2, nxr
+             DO  jp = nys, nyn
+
+                number_of_agents = agt_count(jp,ip)
+                IF ( number_of_agents <= 0 )  CYCLE
+                ghra(ghra_count+1:ghra_count+number_of_agents)                                     &
+                                                   = grid_agents(jp,ip)%agents(1:number_of_agents)
+                ghra_count = ghra_count + number_of_agents
+
+             ENDDO
+          ENDDO
+       ENDIF
+       IF ( ghra_count == 0 ) ghra_count = 1
+!
+!--    Send/receive number of agents that will be transferred to/from left/right neighbor.
+       CALL MPI_SENDRECV( ghla_count,      1, MPI_INTEGER, pleft,  0,                              &
+                          ghra_count_recv, 1, MPI_INTEGER, pright, 0,                              &
+                          comm2d, status, ierr )
+       ALLOCATE ( agt_gh_r(1:ghra_count_recv) )
+!
+!--    Send/receive number of agents that will be transferred to/from right/left neighbor
+       CALL MPI_SENDRECV( ghra_count,      1, MPI_INTEGER, pright,  0,                             &
+                          ghla_count_recv, 1, MPI_INTEGER, pleft,   0,                             &
+                          comm2d, status, ierr )
+!
+!--    Send/receive flag that indicates if there are actually any agents in ghost layer
+       CALL MPI_SENDRECV( ghla_empty,     1, MPI_LOGICAL, pleft, 1,                                &
+                          ghra_empty_rcv, 1, MPI_LOGICAL, pright,1,                                &
+                          comm2d, status, ierr )
+       CALL MPI_SENDRECV( ghra_empty,     1, MPI_LOGICAL, pright,1,                                &
+                          ghla_empty_rcv, 1, MPI_LOGICAL, pleft, 1,                                &
+                          comm2d, status, ierr )
+
+
+       ALLOCATE ( agt_gh_l(1:ghla_count_recv) )
+!
+!--    Get bit size of one agent
+       agt_size = STORAGE_SIZE(zero_agent)/8
+!
+!--    Send/receive agents to/from left/right neighbor
+       CALL MPI_SENDRECV( ghla,     ghla_count      * agt_size, MPI_BYTE, pleft, 1,                &
+                          agt_gh_r, ghra_count_recv * agt_size, MPI_BYTE, pright,1,                &
+                          comm2d, status, ierr )
+!
+!--    Send/receive agents to/from left/right neighbor
+       CALL MPI_SENDRECV( ghra,     ghra_count      * agt_size, MPI_BYTE, pright,1,                &
+                          agt_gh_l, ghla_count_recv * agt_size, MPI_BYTE, pleft, 1,                &
+                          comm2d, status, ierr )
+!
+!--    If agents were received, add them to the respective ghost layer cells
+       IF ( .NOT. ghra_empty_rcv )  THEN
+          CALL mas_eh_add_ghost_agents_to_gridcell(agt_gh_r)
+       ENDIF
+
+       IF ( .NOT. ghla_empty_rcv )  THEN
+          CALL mas_eh_add_ghost_agents_to_gridcell(agt_gh_l)
+       ENDIF
+
+       DEALLOCATE( ghla, ghra, agt_gh_l, agt_gh_r )
+
+    ENDIF
+
+!
+!-- Transfer of agents from south to north and vice versa
+    IF ( pdims(2) /= 1 )  THEN
+!
+!--    Reset south and north ghost layers
+       ghsa_count  = 0
+       ghna_count  = 0
+!
+!--    First calculate the storage necessary for sending and receiving the data.
+       ghsa_count = SUM( agt_count(nys:nys+2,nxlg:nxrg) )
+       ghna_count = SUM( agt_count(nyn-2:nyn,nxlg:nxrg) )
+!
+!--    No cyclic boundaries for agents
+       IF ( nys == 0  .OR.  ghsa_count == 0 )  THEN
+          ghsa_count = 1
+       ELSE
+          ghsa_empty = .FALSE.
+       ENDIF
+       IF ( nyn == ny  .OR.  ghna_count == 0 )  THEN
+          ghna_count = 1
+       ELSE
+          ghna_empty = .FALSE.
+       ENDIF
+       ALLOCATE( ghsa(1:ghsa_count), ghna(1:ghna_count) )
+       ghsa = zero_agent
+       ghna = zero_agent
+!
+!--    Get all agents that will be sent south into one array
+       ghsa_count = 0
+       IF ( nys /= 0 )  THEN
+          DO  ip = nxlg, nxrg
+             DO  jp = nys, nys+2
+
+                number_of_agents = agt_count(jp,ip)
+                IF ( number_of_agents <= 0 )  CYCLE
+                ghsa(ghsa_count+1:ghsa_count+number_of_agents)                                     &
+                                                    = grid_agents(jp,ip)%agents(1:number_of_agents)
+                ghsa_count = ghsa_count + number_of_agents
+
+             ENDDO
+          ENDDO
+       ENDIF
+       IF ( ghsa_count == 0 )  ghsa_count = 1
+!
+!--    Get all agents that will be sent north into one array
+       ghna_count = 0
+       IF ( nyn /= ny )  THEN
+          DO  ip = nxlg, nxrg
+             DO  jp = nyn-2, nyn
+
+                number_of_agents = agt_count(jp,ip)
+                IF ( number_of_agents <= 0 )  CYCLE
+                ghna(ghna_count+1:ghna_count+number_of_agents)                                     &
+                                                     = grid_agents(jp,ip)%agents(1:number_of_agents)
+                ghna_count = ghna_count + number_of_agents
+
+             ENDDO
+          ENDDO
+       ENDIF
+       IF ( ghna_count == 0 ) ghna_count = 1
+!
+!--    Send/receive number of agents that will be transferred to/from south/north neighbor
+       CALL MPI_SENDRECV( ghsa_count,        1, MPI_INTEGER, psouth, 0,                            &
+                          ghna_count_recv,   1, MPI_INTEGER, pnorth, 0,                            &
+                          comm2d, status, ierr )
+       ALLOCATE ( agt_gh_n(1:ghna_count_recv) )
+!
+!--    Send/receive number of agents that will be transferred to/from north/south neighbor
+       CALL MPI_SENDRECV( ghna_count,        1, MPI_INTEGER, pnorth, 0,                            &
+                          ghsa_count_recv,   1, MPI_INTEGER, psouth, 0,                            &
+                          comm2d, status, ierr )
+!
+!--    Send/receive flag that indicates if there are actually any agents in ghost layer
+       CALL MPI_SENDRECV( ghsa_empty,     1, MPI_LOGICAL, psouth, 1,                               &
+                          ghna_empty_rcv, 1, MPI_LOGICAL, pnorth, 1,                               &
+                          comm2d, status, ierr )
+       CALL MPI_SENDRECV( ghna_empty,     1, MPI_LOGICAL, pnorth, 1,                               &
+                          ghsa_empty_rcv, 1, MPI_LOGICAL, psouth, 1,                               &
+                          comm2d, status, ierr )
+
+
+       ALLOCATE ( agt_gh_s(1:ghsa_count_recv) )
+!
+!--    Get bit size of one agent
+       agt_size = STORAGE_SIZE(zero_agent)/8
+!
+!--    Send/receive agents to/from south/north neighbor
+       CALL MPI_SENDRECV( ghsa,     ghsa_count      * agt_size, MPI_BYTE, psouth,1,                &
+                          agt_gh_n, ghna_count_recv * agt_size, MPI_BYTE, pnorth,1,                &
+                          comm2d, status, ierr )
+!
+!--       Send/receive agents to/from south/north neighbor
+       CALL MPI_SENDRECV( ghna,     ghna_count      * agt_size, MPI_BYTE, pnorth,1,                &
+                          agt_gh_s, ghsa_count_recv * agt_size, MPI_BYTE, psouth,1,                &
+                          comm2d, status, ierr )
+!
+!--    If agents were received, add them to the respective ghost layer cells
+       IF ( .NOT. ghna_empty_rcv )  THEN
+          CALL mas_eh_add_ghost_agents_to_gridcell(agt_gh_n)
+       ENDIF
+
+       IF ( .NOT. ghsa_empty_rcv )  THEN
+          CALL mas_eh_add_ghost_agents_to_gridcell(agt_gh_s)
+       ENDIF
+
+       DEALLOCATE( ghna, ghsa, agt_gh_n, agt_gh_s )
+
+    ENDIF
+
+ END SUBROUTINE mas_eh_ghost_exchange
+#endif
+
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> If an agent moves from one grid cell to another (on the current processor!), this subroutine
+!> moves the corresponding element from the agent array of the old grid cell to the agent array of
+!> the new grid cell.
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE mas_eh_move_agent
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  aindex         !< dummy argument for number of new agent per grid box
+    INTEGER(iwp) ::  i              !< grid index (x) of agent position
+    INTEGER(iwp) ::  ip             !< index variable along x
+    INTEGER(iwp) ::  j              !< grid index (y) of agent position
+    INTEGER(iwp) ::  jp             !< index variable along y
+    INTEGER(iwp) ::  n              !< index variable for agent array
+    INTEGER(iwp) ::  na_before_move !< number of agents per grid box before moving
+
+    TYPE(agent_type), DIMENSION(:), POINTER ::  agents_before_move !< agents before moving
+
+    DO  ip = nxl, nxr
+       DO  jp = nys, nyn
+
+             na_before_move = agt_count(jp,ip)
+             IF ( na_before_move <= 0 )  CYCLE
+             agents_before_move => grid_agents(jp,ip)%agents(1:na_before_move)
+
+             DO  n = 1, na_before_move
+                i = agents_before_move(n)%x * ddx
+                j = agents_before_move(n)%y * ddy
+
+!--             For mas_eh_exchange_horiz to work properly agents need to be moved to the outermost
+!--             gridboxes of the respective processor.
+!--             If the agent index is inside the processor the following lines will not change the
+!--             index.
+                i = MIN ( i , nxr )
+                i = MAX ( i , nxl )
+                j = MIN ( j , nyn )
+                j = MAX ( j , nys )
+
+!
+!--             Check if agent has moved to another grid cell.
+                IF ( i /= ip  .OR.  j /= jp )  THEN
+!
+!--                If the agent stays on the same processor, the agent will be added to the agent
+!--                array of the new processor.
+                   number_of_agents = agt_count(j,i)
+                   agents => grid_agents(j,i)%agents(1:number_of_agents)
+
+                   aindex = number_of_agents+1
+                   IF (  aindex > SIZE(grid_agents(j,i)%agents)  )  THEN
+                      CALL mas_eh_realloc_agents_array(i,j)
+                   ENDIF
+
+                   grid_agents(j,i)%agents(aindex) = agents_before_move(n)
+                   agt_count(j,i) = aindex
+
+                   agents_before_move(n)%agent_mask = .FALSE.
                 ENDIF
              ENDDO
-          ENDDO
+
        ENDDO
-
-       DO  ip = nxl, nxr
-          DO  jp = nys, nyn, nyn-nys
-             number_of_agents = agt_count(jp,ip)
-             IF ( number_of_agents <= 0 )  CYCLE
-             agents => grid_agents(jp,ip)%agents(1:number_of_agents)
-             DO  n = 1, number_of_agents
-
-                IF ( agents(n)%y < 0.0_wp )  THEN
-
-                   IF ( ibc_mas_ns == 0 )  THEN
-!
-!--                   Cyclic boundary. Relevant coordinate has to be changed.
-                      agents(n)%y = ( ny + 1 ) * dy + agents(n)%y
-                      agents(n)%origin_y = ( ny + 1 ) * dy + &
-                           agents(n)%origin_y
-
-                   ELSEIF ( ibc_mas_ns == 1 )  THEN
-!
-!--                   Agent absorption
-                      agents(n)%agent_mask = .FALSE.
-                      deleted_agents = deleted_agents + 1
-                   ENDIF
-
-                ELSEIF ( agents(n)%y >= ( ny + 0.5_wp ) * dy )  THEN
-
-                   IF ( ibc_mas_ns == 0 )  THEN
-!
-!--                   Cyclic boundary. Relevant coordinate has to be changed.
-                      agents(n)%y = agents(n)%y - ( ny + 1 ) * dy
-
-                   ELSEIF ( ibc_mas_ns == 1 )  THEN
-!
-!--                   Agent absorption
-                      agents(n)%agent_mask = .FALSE.
-                      deleted_agents = deleted_agents + 1
-                   ENDIF
-
-                ENDIF
-
-             ENDDO
-          ENDDO
-       ENDDO
-#endif
-
-    END SUBROUTINE mas_eh_exchange_horiz
-
-
-#if defined( __parallel )
-!------------------------------------------------------------------------------!
+    ENDDO
+
+    RETURN
+
+ END SUBROUTINE mas_eh_move_agent
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Sends the agents from the three gridcells closest to the 
-!> north/south/left/right border of a PE to the corresponding neighbors ghost
-!> layer (which is three grid boxes deep)
-!------------------------------------------------------------------------------!
-    SUBROUTINE mas_eh_ghost_exchange
+!> If the allocated memory for the agent array does not suffice to add arriving agents from
+!> neighbour grid cells, this subrouting reallocates the agent array to assure enough memory is
+!> available.
+!--------------------------------------------------------------------------------------------------!
+    SUBROUTINE mas_eh_realloc_agents_array (i,j,size_in)
 
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  ip          !< index variable along x
-       INTEGER(iwp) ::  jp          !< index variable along y
-       INTEGER(iwp) ::  agt_size    !< Bit size of agent datatype
-       INTEGER(iwp) ::  ghla_count  !< ghost points left agent
-       INTEGER(iwp) ::  ghna_count  !< ghost points north agent
-       INTEGER(iwp) ::  ghra_count  !< ghost points right agent
-       INTEGER(iwp) ::  ghsa_count  !< ghost points south agent
-
-       LOGICAL ::  ghla_empty      !< ghost points left agent
-       LOGICAL ::  ghla_empty_rcv  !< ghost points left agent
-       LOGICAL ::  ghna_empty      !< ghost points north agent
-       LOGICAL ::  ghna_empty_rcv  !< ghost points north agent
-       LOGICAL ::  ghra_empty      !< ghost points right agent
-       LOGICAL ::  ghra_empty_rcv  !< ghost points right agent
-       LOGICAL ::  ghsa_empty      !< ghost points south agent
-       LOGICAL ::  ghsa_empty_rcv  !< ghost points south agent
-
-       TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  ghla  !< agents received from right PE
-       TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  ghna  !< agents received from south PE
-       TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  ghra  !< agents received from left PE
-       TYPE(agent_type), DIMENSION(:), ALLOCATABLE ::  ghsa  !< agents received from north PE
-
-       ghla_empty = .TRUE.
-       ghna_empty = .TRUE.
-       ghra_empty = .TRUE.
-       ghsa_empty = .TRUE.
-!
-!--    reset ghost layer
-       DO ip = nxlg, nxl-1
-          DO jp = nysg, nyng
-             agt_count(jp,ip) = 0
-          ENDDO
-       ENDDO
-       DO ip = nxr+1, nxrg
-          DO jp = nysg, nyng
-             agt_count(jp,ip) = 0
-          ENDDO
-       ENDDO
-       DO ip = nxl, nxr
-          DO jp = nysg, nys-1
-             agt_count(jp,ip) = 0
-          ENDDO
-       ENDDO
-       DO ip = nxl, nxr
-          DO jp = nyn+1, nyng
-             agt_count(jp,ip) = 0
-          ENDDO
-       ENDDO
-!
-!--    Transfer of agents from left to right and vice versa
-       IF ( pdims(1) /= 1 )  THEN
-!
-!--       Reset left and right ghost layers
-          ghla_count  = 0
-          ghra_count  = 0
-!
-!--       First calculate the storage necessary for sending 
-!--       and receiving the data.
-          ghla_count = SUM(agt_count(nys:nyn,nxl:nxl+2))
-          ghra_count = SUM(agt_count(nys:nyn,nxr-2:nxr))
-!
-!--       No cyclic boundaries for agents
-          IF ( nxl == 0 .OR. ghla_count == 0 ) THEN
-             ghla_count = 1
-          ELSE
-             ghla_empty = .FALSE.
-          ENDIF
-          IF ( nxr == nx .OR. ghra_count == 0 ) THEN
-             ghra_count = 1
-          ELSE
-             ghra_empty = .FALSE.
-          ENDIF
-          ALLOCATE( ghla(1:ghla_count), ghra(1:ghra_count) )
-          ghla = zero_agent
-          ghra = zero_agent
-!
-!--       Get all agents that will be sent left into one array
-          ghla_count = 0
-          IF ( nxl /= 0 ) THEN
-             DO ip = nxl, nxl+2
-                DO jp = nys, nyn
-
-                   number_of_agents = agt_count(jp,ip)
-                   IF ( number_of_agents <= 0 )  CYCLE
-                   ghla(ghla_count+1:ghla_count+number_of_agents)              &
-                       = grid_agents(jp,ip)%agents(1:number_of_agents)
-                   ghla_count = ghla_count + number_of_agents
-
-                ENDDO
-             ENDDO
-          ENDIF
-          IF ( ghla_count == 0 )  ghla_count = 1
-!
-!--       Get all agents that will be sent right into one array
-          ghra_count = 0
-          IF ( nxr /= nx ) THEN
-             DO ip = nxr-2, nxr
-                DO jp = nys, nyn
-
-                   number_of_agents = agt_count(jp,ip)
-                   IF ( number_of_agents <= 0 )  CYCLE
-                   ghra(ghra_count+1:ghra_count+number_of_agents)              &
-                       = grid_agents(jp,ip)%agents(1:number_of_agents)
-                   ghra_count = ghra_count + number_of_agents
-
-                ENDDO
-             ENDDO
-          ENDIF
-          IF ( ghra_count == 0 ) ghra_count = 1
-!
-!--       Send/receive number of agents that 
-!--       will be transferred to/from left/right neighbor
-          CALL MPI_SENDRECV( ghla_count,      1, MPI_INTEGER, pleft,  0,       &
-                             ghra_count_recv, 1, MPI_INTEGER, pright, 0,       &
-                             comm2d, status, ierr )
-          ALLOCATE ( agt_gh_r(1:ghra_count_recv) )
-!
-!--       Send/receive number of agents that 
-!--       will be transferred to/from right/left neighbor
-          CALL MPI_SENDRECV( ghra_count,      1, MPI_INTEGER, pright,  0,      &
-                             ghla_count_recv, 1, MPI_INTEGER, pleft,   0,      &
-                             comm2d, status, ierr )
-!
-!--       Send/receive flag that indicates if there are actually any agents 
-!--       in ghost  layer
-          CALL MPI_SENDRECV( ghla_empty,     1, MPI_LOGICAL, pleft, 1,         &
-                             ghra_empty_rcv, 1, MPI_LOGICAL, pright,1,         &
-                             comm2d, status, ierr )
-          CALL MPI_SENDRECV( ghra_empty,     1, MPI_LOGICAL, pright,1,         &
-                             ghla_empty_rcv, 1, MPI_LOGICAL, pleft, 1,         &
-                             comm2d, status, ierr )
-
-
-          ALLOCATE ( agt_gh_l(1:ghla_count_recv) )
-!
-!--       Get bit size of one agent
-          agt_size = STORAGE_SIZE(zero_agent)/8
-!
-!--       Send/receive agents to/from left/right neighbor
-          CALL MPI_SENDRECV( ghla,     ghla_count      * agt_size, MPI_BYTE,   &
-                                pleft, 1,                                      &
-                             agt_gh_r, ghra_count_recv * agt_size, MPI_BYTE,   &
-                                pright,1,                                      &
-                             comm2d, status, ierr )
-!
-!--       Send/receive agents to/from left/right neighbor
-          CALL MPI_SENDRECV( ghra,     ghra_count      * agt_size, MPI_BYTE,   &
-                                pright,1,                                      &
-                             agt_gh_l, ghla_count_recv * agt_size, MPI_BYTE,   &
-                                pleft, 1,                                      &
-                             comm2d, status, ierr )
-!
-!--       If agents were received, add them to the respective ghost layer cells
-          IF ( .NOT. ghra_empty_rcv ) THEN
-             CALL mas_eh_add_ghost_agents_to_gridcell(agt_gh_r)
-          ENDIF
-
-          IF ( .NOT. ghla_empty_rcv ) THEN
-             CALL mas_eh_add_ghost_agents_to_gridcell(agt_gh_l)
-          ENDIF
-
-          DEALLOCATE( ghla, ghra, agt_gh_l, agt_gh_r )
-
-       ENDIF
-
-!
-!--    Transfer of agents from south to north and vice versa
-       IF ( pdims(2) /= 1 )  THEN
-!
-!--       Reset south and north ghost layers
-          ghsa_count  = 0
-          ghna_count  = 0
-!
-!--       First calculate the storage necessary for sending 
-!--       and receiving the data.
-          ghsa_count = SUM(agt_count(nys:nys+2,nxlg:nxrg))
-          ghna_count = SUM(agt_count(nyn-2:nyn,nxlg:nxrg))
-!
-!--       No cyclic boundaries for agents
-          IF ( nys == 0 .OR. ghsa_count == 0 ) THEN
-             ghsa_count = 1
-          ELSE
-             ghsa_empty = .FALSE.
-          ENDIF
-          IF ( nyn == ny .OR. ghna_count == 0 ) THEN
-             ghna_count = 1
-          ELSE
-             ghna_empty = .FALSE.
-          ENDIF
-          ALLOCATE( ghsa(1:ghsa_count), ghna(1:ghna_count) )
-          ghsa = zero_agent
-          ghna = zero_agent
-!
-!--       Get all agents that will be sent south into one array
-          ghsa_count = 0
-          IF ( nys /= 0 ) THEN
-             DO ip = nxlg, nxrg
-                DO jp = nys, nys+2
-
-                   number_of_agents = agt_count(jp,ip)
-                   IF ( number_of_agents <= 0 )  CYCLE
-                   ghsa(ghsa_count+1:ghsa_count+number_of_agents)              &
-                       = grid_agents(jp,ip)%agents(1:number_of_agents)
-                   ghsa_count = ghsa_count + number_of_agents
-
-                ENDDO
-             ENDDO
-          ENDIF
-          IF ( ghsa_count == 0 )  ghsa_count = 1
-!
-!--       Get all agents that will be sent north into one array
-          ghna_count = 0
-          IF ( nyn /= ny ) THEN
-             DO ip = nxlg, nxrg
-                DO jp = nyn-2, nyn
-
-                   number_of_agents = agt_count(jp,ip)
-                   IF ( number_of_agents <= 0 )  CYCLE
-                   ghna(ghna_count+1:ghna_count+number_of_agents)              &
-                       = grid_agents(jp,ip)%agents(1:number_of_agents)
-                   ghna_count = ghna_count + number_of_agents
-
-                ENDDO
-             ENDDO
-          ENDIF
-          IF ( ghna_count == 0 ) ghna_count = 1
-!
-!--       Send/receive number of agents that 
-!--       will be transferred to/from south/north neighbor
-          CALL MPI_SENDRECV( ghsa_count, 1, MPI_INTEGER, psouth, 0,            &
-                             ghna_count_recv,   1, MPI_INTEGER, pnorth, 0,     &
-                             comm2d, status, ierr )
-          ALLOCATE ( agt_gh_n(1:ghna_count_recv) )
-!
-!--       Send/receive number of agents that 
-!--       will be transferred to/from north/south neighbor
-          CALL MPI_SENDRECV( ghna_count, 1, MPI_INTEGER, pnorth, 0,            &
-                             ghsa_count_recv,   1, MPI_INTEGER, psouth, 0,     &
-                             comm2d, status, ierr )
-!
-!--       Send/receive flag that indicates if there are actually any agents 
-!--       in ghost  layer
-          CALL MPI_SENDRECV( ghsa_empty,     1, MPI_LOGICAL, psouth, 1,        &
-                             ghna_empty_rcv, 1, MPI_LOGICAL, pnorth, 1,        &
-                             comm2d, status, ierr )
-          CALL MPI_SENDRECV( ghna_empty,     1, MPI_LOGICAL, pnorth, 1,        &
-                             ghsa_empty_rcv, 1, MPI_LOGICAL, psouth, 1,        &
-                             comm2d, status, ierr )
-
-
-          ALLOCATE ( agt_gh_s(1:ghsa_count_recv) )
-!
-!--       Get bit size of one agent
-          agt_size = STORAGE_SIZE(zero_agent)/8
-!
-!--       Send/receive agents to/from south/north neighbor
-          CALL MPI_SENDRECV( ghsa,     ghsa_count      * agt_size, MPI_BYTE,   &
-                                psouth,1,                                      &
-                             agt_gh_n, ghna_count_recv * agt_size, MPI_BYTE,   &
-                                pnorth,1,                                      &
-                             comm2d, status, ierr )
-!
-!--       Send/receive agents to/from south/north neighbor
-          CALL MPI_SENDRECV( ghna,     ghna_count      * agt_size, MPI_BYTE,   &
-                                pnorth,1,                                      &
-                             agt_gh_s, ghsa_count_recv * agt_size, MPI_BYTE,   &
-                                psouth,1,                                      &
-                             comm2d, status, ierr )
-!
-!--       If agents were received, add them to the respective ghost layer cells
-          IF ( .NOT. ghna_empty_rcv ) THEN
-             CALL mas_eh_add_ghost_agents_to_gridcell(agt_gh_n)
-          ENDIF
-
-          IF ( .NOT. ghsa_empty_rcv ) THEN
-             CALL mas_eh_add_ghost_agents_to_gridcell(agt_gh_s)
-          ENDIF
-
-          DEALLOCATE( ghna, ghsa, agt_gh_n, agt_gh_s )
-
-       ENDIF
-
-    END SUBROUTINE mas_eh_ghost_exchange
-#endif
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> If an agent moves from one grid cell to another (on the current 
-!> processor!), this subroutine moves the corresponding element from the
-!> agent array of the old grid cell to the agent array of the new grid 
-!> cell.
-!------------------------------------------------------------------------------!
-    SUBROUTINE mas_eh_move_agent
-
-       IMPLICIT NONE
-
-       INTEGER(iwp) ::  i              !< grid index (x) of agent position
-       INTEGER(iwp) ::  ip             !< index variable along x
-       INTEGER(iwp) ::  j              !< grid index (y) of agent position
-       INTEGER(iwp) ::  jp             !< index variable along y
-       INTEGER(iwp) ::  n              !< index variable for agent array
-       INTEGER(iwp) ::  na_before_move !< number of agents per grid box before moving
-       INTEGER(iwp) ::  aindex         !< dummy argument for number of new agent per grid box
-
-       TYPE(agent_type), DIMENSION(:), POINTER ::  agents_before_move !< agents before moving
-
-       DO  ip = nxl, nxr
-          DO  jp = nys, nyn
-
-                na_before_move = agt_count(jp,ip)
-                IF ( na_before_move <= 0 )  CYCLE
-                agents_before_move => grid_agents(jp,ip)%agents(1:na_before_move)
-
-                DO  n = 1, na_before_move
-                   i = agents_before_move(n)%x * ddx
-                   j = agents_before_move(n)%y * ddy
-
-!--                For mas_eh_exchange_horiz to work properly agents need to be
-!--                moved to the outermost gridboxes of the respective processor.
-!--                If the agent index is inside the processor the following
-!--                lines will not change the index
-                   i = MIN ( i , nxr )
-                   i = MAX ( i , nxl )
-                   j = MIN ( j , nyn )
-                   j = MAX ( j , nys )
-
-!
-!--                Check if agent has moved to another grid cell.
-                   IF ( i /= ip  .OR.  j /= jp )  THEN
-!
-!--                   If the agent stays on the same processor, the agent
-!--                   will be added to the agent array of the new processor.
-                      number_of_agents = agt_count(j,i)
-                      agents => grid_agents(j,i)%agents(1:number_of_agents)
-
-                      aindex = number_of_agents+1
-                      IF (  aindex > SIZE(grid_agents(j,i)%agents)  )     &
-                      THEN
-                         CALL mas_eh_realloc_agents_array(i,j)
-                      ENDIF
-
-                      grid_agents(j,i)%agents(aindex) = agents_before_move(n)
-                      agt_count(j,i) = aindex
-
-                      agents_before_move(n)%agent_mask = .FALSE.
-                   ENDIF
-                ENDDO
-
-          ENDDO
-       ENDDO
-
-       RETURN
-
-    END SUBROUTINE mas_eh_move_agent
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> If the allocated memory for the agent array do not suffice to add arriving
-!> agents from neighbour grid cells, this subrouting reallocates the 
-!> agent array to assure enough memory is available. 
-!------------------------------------------------------------------------------!
-    SUBROUTINE mas_eh_realloc_agents_array (i,j,size_in)
-
-       IMPLICIT NONE
-
+       INTEGER(iwp) :: new_size  !< new array size
        INTEGER(iwp) :: old_size  !< old array size
-       INTEGER(iwp) :: new_size  !< new array size
 
        INTEGER(iwp), INTENT(in) ::  i  !< grid index (y)
